import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class Counter
{
    private File inputFile;
    
    public Counter(File inputFile)
    {
        this.inputFile = inputFile;
    }
    
    public int countLines()
    {
        int count = 0;
        Scanner in = null;
        
        try {
            in = new Scanner(inputFile);
            
            while (in.hasNextLine()) {
                in.nextLine();
                ++count;
            }
        }
        catch (FileNotFoundException ex) {
            ex.printStackTrace();
        }
        finally {
            if (in != null) in.close();
        }
        
        return count;
    }

    public int countWords()
    {
        int count = 0;
        Scanner in = null;
        
        try {
            in = new Scanner(inputFile);
            
            while (in.hasNext()) {
                in.next();
                ++count;
            }
        }
        catch (FileNotFoundException ex) {
            ex.printStackTrace();
        }
        finally {
            if (in != null) in.close();
        }
        
        return count;
    }

    public int countChars(CharacterStats stats)
    {
        int count = 0;
        Scanner in = null;
        
        try {
            in = new Scanner(inputFile);
            in.useDelimiter("");

            while (in.hasNext()) {
                char ch = in.next().charAt(0);
                ++count;
                
                if      (Character.isDigit(ch))      stats.incDigit();
                else if (Character.isLowerCase(ch))  stats.incLower();
                else if (Character.isUpperCase(ch))  stats.incUpper();
                else if (Character.isWhitespace(ch)) stats.incWhite();
                else                                 stats.incOther();
            }
        }
        catch (FileNotFoundException ex) {
            ex.printStackTrace();
        }
        finally {
            if (in != null) in.close();
        }
        
        return count;
    }
}
